/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/


using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace symmetry
{
	/// <summary>
	/// Summary description for Draw_graph.
	/// </summary>
	public class Draw_graph_2 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.StatusBar statusBar1;
		private Graphics g;
		private Pen p;
		private System.Windows.Forms.HScrollBar hScrollBar1;
		private System.Windows.Forms.VScrollBar vScrollBar1;
		private System.ComponentModel.IContainer components;
		private int LastScroll_V = 0;
		private int LastScroll_H = 0;
		private Line horizon = new Line();
		private Line vertica = new Line();
		private System.Windows.Forms.Panel panel2;
		private bool cordinatesRead = false;
		private System.Windows.Forms.MenuItem menuItem4;
		Graph graph =  new Graph();
		Graph graphS = new Graph();
		
		
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.GroupBox Legenda_box;
		private System.Windows.Forms.GroupBox Legenda_speed;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Button button8;
		private System.Windows.Forms.Button button9;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label4;
		
	

		public Draw_graph_2()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Draw_graph_2));
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.Legenda_speed = new System.Windows.Forms.GroupBox();
			this.label11 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.button9 = new System.Windows.Forms.Button();
			this.button8 = new System.Windows.Forms.Button();
			this.button7 = new System.Windows.Forms.Button();
			this.button6 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.Legenda_box = new System.Windows.Forms.GroupBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.button3 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.hScrollBar1 = new System.Windows.Forms.HScrollBar();
			this.vScrollBar1 = new System.Windows.Forms.VScrollBar();
			this.panel2 = new System.Windows.Forms.Panel();
			this.panel1.SuspendLayout();
			this.panel3.SuspendLayout();
			this.Legenda_speed.SuspendLayout();
			this.Legenda_box.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Controls.Add(this.panel3);
			this.panel1.Enabled = ((bool)(configurationAppSettings.GetValue("panel1.Enabled", typeof(bool))));
			this.panel1.Location = new System.Drawing.Point(5, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(4984, 5000);
			this.panel1.TabIndex = 0;
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			// 
			// panel3
			// 
			this.panel3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.panel3.BackColor = System.Drawing.Color.Transparent;
			this.panel3.Controls.Add(this.Legenda_speed);
			this.panel3.Controls.Add(this.Legenda_box);
			this.panel3.ForeColor = System.Drawing.Color.Silver;
			this.panel3.Location = new System.Drawing.Point(360, 0);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(128, 296);
			this.panel3.TabIndex = 1;
			// 
			// Legenda_speed
			// 
			this.Legenda_speed.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.Legenda_speed.Controls.Add(this.label11);
			this.Legenda_speed.Controls.Add(this.label10);
			this.Legenda_speed.Controls.Add(this.label9);
			this.Legenda_speed.Controls.Add(this.label8);
			this.Legenda_speed.Controls.Add(this.label7);
			this.Legenda_speed.Controls.Add(this.label6);
			this.Legenda_speed.Controls.Add(this.label5);
			this.Legenda_speed.Controls.Add(this.button9);
			this.Legenda_speed.Controls.Add(this.button8);
			this.Legenda_speed.Controls.Add(this.button7);
			this.Legenda_speed.Controls.Add(this.button6);
			this.Legenda_speed.Controls.Add(this.button5);
			this.Legenda_speed.Controls.Add(this.button4);
			this.Legenda_speed.Location = new System.Drawing.Point(9, 4);
			this.Legenda_speed.Name = "Legenda_speed";
			this.Legenda_speed.Size = new System.Drawing.Size(114, 282);
			this.Legenda_speed.TabIndex = 1;
			this.Legenda_speed.TabStop = false;
			this.Legenda_speed.Visible = false;
			// 
			// label11
			// 
			this.label11.ForeColor = System.Drawing.Color.Black;
			this.label11.Location = new System.Drawing.Point(16, 13);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(90, 19);
			this.label11.TabIndex = 12;
			this.label11.Text = "Legenda - hitrost";
			// 
			// label10
			// 
			this.label10.ForeColor = System.Drawing.Color.Black;
			this.label10.Location = new System.Drawing.Point(51, 245);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(55, 25);
			this.label10.TabIndex = 11;
			this.label10.Text = ">500";
			// 
			// label9
			// 
			this.label9.ForeColor = System.Drawing.Color.Black;
			this.label9.Location = new System.Drawing.Point(53, 204);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(52, 27);
			this.label9.TabIndex = 10;
			this.label9.Text = "400-500";
			// 
			// label8
			// 
			this.label8.ForeColor = System.Drawing.Color.Black;
			this.label8.Location = new System.Drawing.Point(53, 165);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(50, 22);
			this.label8.TabIndex = 9;
			this.label8.Text = "300-400";
			// 
			// label7
			// 
			this.label7.ForeColor = System.Drawing.Color.Black;
			this.label7.Location = new System.Drawing.Point(53, 126);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(50, 21);
			this.label7.TabIndex = 8;
			this.label7.Text = "200-300";
			// 
			// label6
			// 
			this.label6.ForeColor = System.Drawing.Color.Black;
			this.label6.Location = new System.Drawing.Point(53, 84);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(56, 23);
			this.label6.TabIndex = 7;
			this.label6.Text = "100 -200";
			// 
			// label5
			// 
			this.label5.ForeColor = System.Drawing.Color.Black;
			this.label5.Location = new System.Drawing.Point(53, 42);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(54, 24);
			this.label5.TabIndex = 6;
			this.label5.Text = "0 -100";
			// 
			// button9
			// 
			this.button9.BackColor = System.Drawing.Color.Blue;
			this.button9.ForeColor = System.Drawing.Color.Transparent;
			this.button9.Location = new System.Drawing.Point(12, 237);
			this.button9.Name = "button9";
			this.button9.Size = new System.Drawing.Size(30, 30);
			this.button9.TabIndex = 5;
			this.button9.Text = "button9";
			// 
			// button8
			// 
			this.button8.BackColor = System.Drawing.Color.Green;
			this.button8.ForeColor = System.Drawing.Color.Transparent;
			this.button8.Location = new System.Drawing.Point(12, 197);
			this.button8.Name = "button8";
			this.button8.Size = new System.Drawing.Size(30, 30);
			this.button8.TabIndex = 4;
			this.button8.Text = "button8";
			// 
			// button7
			// 
			this.button7.BackColor = System.Drawing.Color.Red;
			this.button7.ForeColor = System.Drawing.Color.Transparent;
			this.button7.Location = new System.Drawing.Point(12, 157);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(30, 30);
			this.button7.TabIndex = 3;
			this.button7.Text = "button7";
			// 
			// button6
			// 
			this.button6.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(0)));
			this.button6.ForeColor = System.Drawing.Color.Transparent;
			this.button6.Location = new System.Drawing.Point(12, 117);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(30, 30);
			this.button6.TabIndex = 2;
			this.button6.Text = "button6";
			// 
			// button5
			// 
			this.button5.BackColor = System.Drawing.Color.Salmon;
			this.button5.ForeColor = System.Drawing.Color.Transparent;
			this.button5.Location = new System.Drawing.Point(12, 77);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(30, 30);
			this.button5.TabIndex = 1;
			this.button5.Text = "button5";
			// 
			// button4
			// 
			this.button4.BackColor = System.Drawing.Color.Yellow;
			this.button4.ForeColor = System.Drawing.Color.Transparent;
			this.button4.Location = new System.Drawing.Point(12, 37);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(30, 30);
			this.button4.TabIndex = 0;
			this.button4.Text = "button4";
			// 
			// Legenda_box
			// 
			this.Legenda_box.BackColor = System.Drawing.Color.Transparent;
			this.Legenda_box.Controls.Add(this.label4);
			this.Legenda_box.Controls.Add(this.label3);
			this.Legenda_box.Controls.Add(this.label2);
			this.Legenda_box.Controls.Add(this.label1);
			this.Legenda_box.Controls.Add(this.button3);
			this.Legenda_box.Controls.Add(this.button2);
			this.Legenda_box.Controls.Add(this.button1);
			this.Legenda_box.Location = new System.Drawing.Point(14, 4);
			this.Legenda_box.Name = "Legenda_box";
			this.Legenda_box.Size = new System.Drawing.Size(114, 176);
			this.Legenda_box.TabIndex = 0;
			this.Legenda_box.TabStop = false;
			this.Legenda_box.Visible = false;
			this.Legenda_box.Enter += new System.EventHandler(this.groupBox1_Enter_2);
			// 
			// label4
			// 
			this.label4.BackColor = System.Drawing.Color.Transparent;
			this.label4.ForeColor = System.Drawing.Color.Black;
			this.label4.Location = new System.Drawing.Point(8, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 16);
			this.label4.TabIndex = 8;
			this.label4.Text = "Legenda - koti";
			this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label3
			// 
			this.label3.ForeColor = System.Drawing.Color.Black;
			this.label3.Location = new System.Drawing.Point(48, 136);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(64, 24);
			this.label3.TabIndex = 5;
			this.label3.Text = "120 - 180 ";
			// 
			// label2
			// 
			this.label2.ForeColor = System.Drawing.Color.Black;
			this.label2.Location = new System.Drawing.Point(48, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 24);
			this.label2.TabIndex = 4;
			this.label2.Text = "60 - 120 ";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.ForeColor = System.Drawing.Color.Black;
			this.label1.Location = new System.Drawing.Point(48, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(40, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "0 - 60 ";
			// 
			// button3
			// 
			this.button3.BackColor = System.Drawing.Color.Blue;
			this.button3.ForeColor = System.Drawing.Color.Transparent;
			this.button3.Location = new System.Drawing.Point(8, 128);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(32, 32);
			this.button3.TabIndex = 2;
			this.button3.Text = "button3";
			// 
			// button2
			// 
			this.button2.BackColor = System.Drawing.Color.Green;
			this.button2.ForeColor = System.Drawing.Color.Transparent;
			this.button2.Location = new System.Drawing.Point(8, 88);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(32, 32);
			this.button2.TabIndex = 1;
			this.button2.Text = "button2";
			// 
			// button1
			// 
			this.button1.BackColor = System.Drawing.Color.DarkRed;
			this.button1.ForeColor = System.Drawing.Color.Transparent;
			this.button1.Location = new System.Drawing.Point(8, 48);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(32, 32);
			this.button1.TabIndex = 0;
			this.button1.Text = "button1";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem3,
																					  this.menuItem4});
			this.menuItem1.Text = "File ";
			// 
			// menuItem3
			// 
			this.menuItem3.Checked = true;
			this.menuItem3.Index = 0;
			this.menuItem3.Text = "Angle";
			this.menuItem3.Click += new System.EventHandler(this.menu_angle_click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 1;
			this.menuItem4.Text = "Speed";
			this.menuItem4.Click += new System.EventHandler(this.menu_speed_click);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 351);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(512, 22);
			this.statusBar1.TabIndex = 1;
			this.statusBar1.Text = "Ready";
			// 
			// hScrollBar1
			// 
			this.hScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.hScrollBar1.LargeChange = 200;
			this.hScrollBar1.Location = new System.Drawing.Point(0, 0);
			this.hScrollBar1.Maximum = 4700;
			this.hScrollBar1.Name = "hScrollBar1";
			this.hScrollBar1.Size = new System.Drawing.Size(496, 16);
			this.hScrollBar1.SmallChange = 100;
			this.hScrollBar1.TabIndex = 2;
			this.hScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.hScrollBar1_Scroll);
			// 
			// vScrollBar1
			// 
			this.vScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.vScrollBar1.LargeChange = 200;
			this.vScrollBar1.Location = new System.Drawing.Point(496, 0);
			this.vScrollBar1.Maximum = 4800;
			this.vScrollBar1.Name = "vScrollBar1";
			this.vScrollBar1.Size = new System.Drawing.Size(16, 336);
			this.vScrollBar1.SmallChange = 100;
			this.vScrollBar1.TabIndex = 3;
			this.vScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vScrollBar1_Scroll);
			// 
			// panel2
			// 
			this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel2.Controls.Add(this.hScrollBar1);
			this.panel2.Location = new System.Drawing.Point(0, 336);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(520, 16);
			this.panel2.TabIndex = 4;
			// 
			// Draw_graph_2
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(512, 373);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.vScrollBar1);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Draw_graph_2";
			this.Text = "Draw_graph 2";
			this.Resize += new System.EventHandler(this.Draw_graph_Resize);
			this.panel1.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.Legenda_speed.ResumeLayout(false);
			this.Legenda_box.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void menuItem2_Click(object sender, System.EventArgs e) //File->Exit
		{
			Draw_graph_2.ActiveForm.Close();	
		}

		public void inicialise(Strokes1 allStrokes) //funkcije kjer vstopamo v to formo
		{
			int i = 0,j = 0,s1,s2,s3,t1,t2,t3,v1,v2,index;
			Stroke1 st;
			OneRectangle  r1,r2,r3,r22;
			double recognition = 0.0,d1,d2,d3;
			
			for(i = 0;i < allStrokes.numberOfStrokes();i++)
			{
				r1 = new OneRectangle();  
				r2 = new OneRectangle();  
				r3 = new OneRectangle();
				r22= new OneRectangle();
				s1=s2=s3=0;
				d1=d2=d3=0;

				st = allStrokes.returnStrokeObject(i);
				
				for(j = 0; j<st.numberOfPoints();j++)
				{
					
                    recognition = st.returnRecognitionAngle(j);
					if (recognition==-1) continue;
					t1=t2=t3=0;
					if (recognition >= 0 && recognition <= 60) 
					{		
						
				        s1++; t1++;
						d1=d1+recognition;
						r1.increaseNumElements();
						
					}
					else 
					{
						if(recognition >60 && recognition < 120) 
						{    
							s2++; t2++;
							d2=d2+recognition;
							r2.increaseNumElements();
							
						}
						else 
						if (recognition != -1 && recognition > 120 && recognition <=180)
						{
							s3++; t3++;
							d3=d3+recognition;		
							r3.increaseNumElements();
						}
						

					}
					if (st.returnElement(j)==st.getPoint()) 
					{
						if (t1!=0) r1.setCorner();
						else if (t2!=0) r2.setCorner();
						else if (t3!=0) r3.setCorner();
					}
					

				}  //for j
				
				if (s1!=0) r1.addDegree(d1/s1);
				//else r1.addAngleDegree(-1);
				if (s2!=0) r2.addDegree(d2/s2);
				//else r2.addAngleDegree(-1);
				if (s3!=0) r3.addDegree(d3/s3);
                //else r3.addAngleDegree(-1);
  
				if (graph.numberOfElements()==0)
				{
					if (r1.returnNumOfElem()!=0) graph.addRectangle(r1);
					if (r2.returnNumOfElem()!=0) graph.addRectangle(r2);
					if (r3.returnNumOfElem()!=0) graph.addRectangle(r3);
				}
				else 
				{
					// r1
					index=0;
					v1=graph.returnRect(index).returnNumOfElem();
					v2=r1.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graph.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
						{
							//graph.InsertRectangle(++index,r1);
							v1=graph.returnRect(++index).returnNumOfElem();
						}//while	
						graph.InsertRectangle(index,r1);
					} //if
					//r2  ----------------------------------
					index=0;
					v1=graph.returnRect(index).returnNumOfElem();
					v2=r2.returnNumOfElem();
					if (v2!=0)
					{
						while ((v2 > v1)&&(index <= graph.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
						{
							//graph.InsertRectangle(++index,r1);
							v1=graph.returnRect(++index).returnNumOfElem();
						}//while	
						graph.InsertRectangle(index,r2);
					} //if
					//r3  -----------------------------------------
					index=0;
					v1=graph.returnRect(index).returnNumOfElem();
					v2=r3.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graph.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
						{
							//graph.InsertRectangle(++index,r1);
							v1=graph.returnRect(++index).returnNumOfElem(); 
						}//while
						//if (index==graph.numberOfElements()-1) graph.addRectangle(r3);
						graph.InsertRectangle(index,r3);
					} //if

				} //else
               
			} //for i

        

		}

		public void inicialiseS(Strokes1 stA)  //nastavitev vseh elementov za prikaz hitrosti
		{	
			int i,j,s1,s2,s3,s4,s5,s6,t1,t2,t3,t4,t5,t6,index,v1,v2;
			Stroke1 st1;
			double speed,d1,d2,d3,d4,d5,d6;
			OneRectangle r1,r2,r3,r4,r5,r6;
			s1=s2=s3=s4=s5=s6=0;
			d1=d2=d3=d4=d5=d6=0;
           
			

	        for (i=0; i< stA.numberOfStrokes(); i++) 
			{
				st1 = stA.returnStrokeObject(i);
				r1 = new OneRectangle();
				r2 = new OneRectangle();
				r3 = new OneRectangle();
				r4 = new OneRectangle();
				r5 = new OneRectangle();
				r6 = new OneRectangle();
				s1=s2=s3=s4=s5=s6=0;
				d1=d2=d3=d4=d5=d6=0;
           
                
				for (j=0; j<st1.numberOfPoints(); j++)
				{	
					speed=st1.returnRecognitionSpeed(j);
					t1=t2=t3=t4=t5=t6=0;
					if (speed < 100) 
					{
						s1++; t1++;
						d1=d1+speed;
						r1.increaseNumElements();
					}
					else if (speed < 200)
					{
						s2++; t2++;
						d2=d2+speed;
						r2.increaseNumElements();
					}
					else if (speed < 300)
					{
						s3++; t3++;
						d3=d3+speed;
						r3.increaseNumElements();
					}
					else if (speed < 400)
					{
						s4++; t4++;
						d4=d4+speed;
						r4.increaseNumElements();
					}
					else if (speed < 500) 
					{
						s5++; t5++;
						d5=d5+speed;
						r5.increaseNumElements();
					}
					else if (speed >= 500)
					{
						s6++; t6++;
						d6=d6+speed;
						r6.increaseNumElements();
					}
					else System.Console.WriteLine("Napaka! {0}",speed);
					if (st1.returnElement(j)==st1.getPoint()) 
					{
						if (t1!=0) r1.setCorner();
						else if (t2!=0) r2.setCorner();
						else if (t3!=0) r3.setCorner();
						else if (t4!=0) r4.setCorner();
						else if (t5!=0) r5.setCorner();
						else if (t6!=0) r6.setCorner();

					}
                    
				}  //for j
				if (s1!=0) r1.addDegree(d1/s1);  //povprne hitrosti
				if (s2!=0) r2.addDegree(d2/s2);
				if (s3!=0) r3.addDegree(d3/s3);
				if (s4!=0) r4.addDegree(d4/s4);
				if (s5!=0) r5.addDegree(d5/s5);
				if (s6!=0) r6.addDegree(d6/s6);

				if (graphS.numberOfElements()==0) //dodajamo prvic
				{
					index=0;
					v1=r1.returnNumOfElem();
					if (v1!=0) graphS.addRectangle(r1);
					//----------------------------------------------
                    v2=r2.returnNumOfElem();
					if (v2!=0) 
					{
						if (v2>=v1) graphS.addRectangle(r2);
						else graphS.InsertRectangle(0,r2);
					} //if
					//r3  ---------------------------------------------
					v1=r3.returnNumOfElem();
					if (v1!=0) 
					{
						if (v2 <= v1) graphS.addRectangle(r3);
						else 
						{
							index=0;
							v2=graphS.returnRect(index).returnNumOfElem();
							while ((v1 > v2)&&(index <= graphS.numberOfElements()-2)) 
								v2=graphS.returnRect(++index).returnNumOfElem();
							
							graphS.InsertRectangle(index,r3);
						} //else 
					} //if
					// r4 --------------------------------------------------
					v1=r4.returnNumOfElem();
					v2=graphS.returnRect(graphS.numberOfElements()-1).returnNumOfElem();
					if (v1!=0) 
					{
						if (v2 <= v1) graphS.addRectangle(r4);
						else 
						{
							index=0;
							v2=graphS.returnRect(index).returnNumOfElem();
							while ((v1 > v2)&&(index <= graphS.numberOfElements()-2)) 
								v2=graphS.returnRect(++index).returnNumOfElem();
							
							graphS.InsertRectangle(index,r4);
						} //else 
					} //if
					// r5 --------------------------------------------------
					v1=r5.returnNumOfElem();
					v2=graphS.returnRect(graphS.numberOfElements()-1).returnNumOfElem();
					if (v1!=0) 
					{
						if (v2 <= v1) graphS.addRectangle(r5);
						else 
						{
							index=0;
							v2=graphS.returnRect(index).returnNumOfElem();
							while ((v1 > v2)&&(index <= graphS.numberOfElements()-2)) 
								v2=graphS.returnRect(++index).returnNumOfElem();
							
							graphS.InsertRectangle(index,r5);
						} //else 
					} //if
					// r6 --------------------------------------------------
					v1=r6.returnNumOfElem();
					v2=graphS.returnRect(graphS.numberOfElements()-1).returnNumOfElem();
					if (v1!=0) 
					{
						if (v2 <= v1) graphS.addRectangle(r6);
						else 
						{
							index=0;
							v2=graphS.returnRect(index).returnNumOfElem();
							while ((v1 > v2)&&(index <= graphS.numberOfElements()-2)) 
								v2=graphS.returnRect(++index).returnNumOfElem();
							
							graphS.InsertRectangle(index,r6);
						} //else 
					} //if

				} //if
				else   //uredimo stolpce
	            {
					// r1-----------------------------------------------
					index=0;
					v1=graphS.returnRect(index).returnNumOfElem();
					v2=r1.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graphS.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
							v1=graphS.returnRect(++index).returnNumOfElem();
							
						graphS.InsertRectangle(index,r1);
					} //if
					//  r2 ----------------------------------------------------
					index=0;
					v1=graphS.returnRect(index).returnNumOfElem();
					v2=r2.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graphS.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
							v1=graphS.returnRect(++index).returnNumOfElem();
							
     					graphS.InsertRectangle(index,r2);
					} //if
					// r3--------------------------------------------------------
					index=0;
					v1=graphS.returnRect(index).returnNumOfElem();
					v2=r3.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graphS.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
							v1=graphS.returnRect(++index).returnNumOfElem();
							
						graphS.InsertRectangle(index,r3);
					} //if
					// r4 ---------------------------------------------------------
					index=0;
					v1=graphS.returnRect(index).returnNumOfElem();
					v2=r4.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graphS.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen					
							v1=graphS.returnRect(++index).returnNumOfElem();
							
    					graphS.InsertRectangle(index,r4);
					} //if
					// r5 ----------------------------------------------------------
					index=0;
					v1=graphS.returnRect(index).returnNumOfElem();
					v2=r5.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graphS.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
							v1=graphS.returnRect(++index).returnNumOfElem();
							
						graphS.InsertRectangle(index,r5);
					} //if
					// r6 ---------------------------------------------------------
					index=0;
					v1=graphS.returnRect(index).returnNumOfElem();
					v2=r6.returnNumOfElem();
					if (v2!=0) 
					{
						while ((v2 > v1)&&(index <= graphS.numberOfElements()-2)) //stolpec pomikamo dokler ni urejen
						   v1=graphS.returnRect(++index).returnNumOfElem();
							
				        graphS.InsertRectangle(index,r6);
					} //if
				
				} //else 

 			} //for i

		} //inicialiseS()

		public void narisiObjekteS()
		{

			int sirina=25, visina, colorR=2,i;
			OneRectangle oneRec;
			Point p1 = new Point();
			Point p2 = new Point();
			Font f = new Font("Arial",8);

            
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.Red);
				this.Controls.Add(panel1);
			}
			g.Clear(Color.White);
		    this.drawLines();
			this.Legenda_box.Visible = false;
			this.Legenda_speed.Visible = true;
		
			p1.X = horizon.returnFirstPoint().X;
			p1.Y = vertica.returnFirstPoint().Y;
            
			p1.X = p1.X + 10;	//zacetni odmik
			if ((int)(graphS.numberOfElements())<=20) 
				sirina = 25;
			else if (graphS.numberOfElements()> 20) 
				sirina=(int)(300/graph.numberOfElements());

			for (i=0; i < graphS.numberOfElements(); i++)
			{
				oneRec=graphS.returnRect(i);
                
 				if (oneRec.getDegree()<100) colorR=7;
				else if (oneRec.getDegree()<200) colorR=6;
				else if (oneRec.getDegree() <300) colorR=5;
				else if (oneRec.getDegree() <400) colorR=1;
				else if (oneRec.getDegree() <500) colorR=3;
				else if (oneRec.getDegree() >=500) colorR=4;
				else System.Console.WriteLine("hitrost je {0}", oneRec.getDegree());
				
				visina=oneRec.returnNumOfElem()*2;
				this.drawRectangle(colorR,p1.X,p1.Y-visina-1,sirina,visina);
				p1.X=p1.X + sirina + (int)p.Width;
				
				if (oneRec.getCorner()) //oznaitev stolpca, kjer se nahaja kot
				{
					p.Color=Color.Black;
					g.DrawString(('*').ToString(),f,p.Brush,p1.X-sirina+1,p1.Y-visina-30); 
				}

				if (sirina >= 20) 
				{
					p.Color=Color.Black;
					g.DrawString(((int)(oneRec.getDegree())).ToString(),
						f,p.Brush,p1.X-sirina,p1.Y-visina-20);  
              
					p.Color=Color.Green; //tevilo tok v tej kategoriji
					g.DrawString((visina/2).ToString(),f,p.Brush,p1.X-sirina+5,p1.Y+5);
				}

				
			}  //for

		}  //narisiObjekteS()

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if (this.menuItem3.Checked == true) this.narisiObjekte1();
			else if (this.menuItem4.Checked == true) this.narisiObjekteS(); 
		}

		private void narisiObjekte1()
		{
			
			int i = 0;
			int sirina = 1;
			int visina = 1;
			int colorR=2;
				
			OneRectangle oneRec;
			Point p1 = new Point();
			Point p2 = new Point();
			Font f = new Font("Arial",8);
            
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.Red);
				this.Controls.Add(panel1);
			}
		
			g.Clear(Color.White);
			this.drawLines();
			this.Legenda_box.Visible = true;
			this.Legenda_speed.Visible = false;
			
			p1.X = horizon.returnFirstPoint().X;
			p1.Y = vertica.returnFirstPoint().Y;
            
			p1.X = p1.X + 10;	//zacetni odmik
            
			if ((int)(graph.numberOfElements()/3)<=10) 
				sirina = 25;
			else if (graph.numberOfElements()> 10) 
				sirina=(int)(250/(int)(graph.numberOfElements()/3));
			
			for(i = 0;i < graph.numberOfElements();i++)
			{
				oneRec=graph.returnRect(i); 
				//System.Console.WriteLine("Uueee i je: {0}", i);
                
				visina=oneRec.returnNumOfElem()*2; 
					//visina=(int)oneRec.getAngleDegree();
					//System.Console.WriteLine("stevilo je {0} je {1} ter /{2}",i,visina,mnozilnik);
					
                    
					if (oneRec.getDegree()<60) colorR=1;
					else if (oneRec.getDegree()<120) colorR=3;
					else if (oneRec.getDegree() <=180) colorR=4;
					else System.Console.WriteLine("povprecen kot je {0}", oneRec.getDegree());
				
					this.drawRectangle(colorR,p1.X,p1.Y-visina-1,sirina,visina);
					p1.X=p1.X + sirina+ (int)p.Width; 
				

					if (oneRec.getCorner()) 
					{
						p.Color=Color.Black;
						g.DrawString(('*').ToString(),f,p.Brush,p1.X-sirina+5,p1.Y-visina-30); 
					}

					if (sirina == 25) 
					{

						p.Color=Color.Black;
						g.DrawString(((int)(oneRec.getDegree())).ToString(),
							f,p.Brush,p1.X-sirina,p1.Y-visina-20); 
					
              
						p.Color=Color.Green;
						g.DrawString((visina/2).ToString(),f,p.Brush,p1.X-sirina+5,p1.Y+5); //tevilo tok v tej kategoriji
					}
             
				}
	
		
			//	drawClasificationLine(p2.X);

					
		//	if(this.vScrollBar1.Location.X-20 < p1.X)
		//		vertica.addLastPoint(p1.X+20,this.panel2.Location.Y-20);
			
		}  //narisi objekte1()



		private void drawLines()  //nariemo koordinatni sistem
		{
			p.Width = 3;
			p.Color = Color.Black;
			
			p.Alignment = PenAlignment.Center;
			p.StartCap = LineCap.ArrowAnchor;

			if(!cordinatesRead)
			{
				horizon.addFirstPoint(this.panel1.Location.X+10,
					this.panel1.Location.Y+10);
				horizon.addLastPoint(this.panel1.Location.X+10,
					this.panel2.Location.Y-10);
				
				vertica.addFirstPoint(this.panel1.Location.X,
					this.panel2.Location.Y-20);
			
				vertica.addLastPoint(this.vScrollBar1.Location.X-20,
					this.panel2.Location.Y-20);
				cordinatesRead = true;
			}
		
			Point po1 = new Point();
			Point po2 = new Point();

			po1 = horizon.returnFirstPoint();
			po2 = horizon.returnLastPoint();

			g.DrawLine(p,po1,po2);
				
			p.StartCap = LineCap.Round;
			p.EndCap = LineCap.ArrowAnchor;

			po1 = vertica.returnFirstPoint();
			po2 = vertica.returnLastPoint();

			g.DrawLine(p,po1,po2);
		
			p.EndCap = LineCap.Round;
		}

		private void drawRectangle(int which,int x,int y,int sirina,int visina)
		{

			Rectangle r;

			p.Width = 1;
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.Red);
				this.Controls.Add(panel1);
			}
			if(which == 1)
			{
		        p.Color = Color.Red;
                r = new Rectangle(x,y,sirina,visina);
	            g.FillRectangle(p.Brush,r);	 
				p.Color = Color.DarkRed;
				g.DrawRectangle(p,r);
			}
			else if(which == 2)  //prazen stolpec (nepobarvan)
			{
				r = new Rectangle(x,y,sirina,visina);
				p.Color = Color.Black;
				g.DrawRectangle(p,r);
			}
			else if (which == 3) 
			{
				p.Color = Color.Green;
                r = new Rectangle(x,y,sirina,visina);
		        g.FillRectangle(p.Brush,r);	 
			    p.Color = Color.DarkOliveGreen;
				g.DrawRectangle(p,r);
			}
			else if (which == 4)
			{
				p.Color = Color.Blue;
                r = new Rectangle(x,y,sirina,visina);
		        g.FillRectangle(p.Brush,r);	 
	            p.Color=Color.DarkBlue;
				g.DrawRectangle(p,r);
			}
			else if (which == 5)
			{
				p.Color = Color.Orange;
				r = new Rectangle(x,y,sirina,visina);
				g.FillRectangle(p.Brush,r);	 
				p.Color=Color.DarkOrange;
				g.DrawRectangle(p,r);
			}
			else if (which == 6)
			{
				p.Color = Color.Salmon;
				r = new Rectangle(x,y,sirina,visina);
				g.FillRectangle(p.Brush,r);	 
				p.Color=Color.DarkSalmon;
				g.DrawRectangle(p,r);
			}
			else if (which == 7)
			{
				p.Color = Color.Yellow;
				r = new Rectangle(x,y,sirina,visina);
				g.FillRectangle(p.Brush,r);	 
				p.Color=Color.YellowGreen;
				g.DrawRectangle(p,r);
			}


		
		}

		private void drawClasificationLine(int x)		//tocka na vodoravni premici
		{

			p.Color = Color.Blue;
			p.Width = 2;
			g.DrawLine(p,x,vertica.returnFirstPoint().Y,x,horizon.returnFirstPoint().Y);		

		}
		/*--------------------------------------------------------------------------------------------------------------*/
		/*---------------------------------------SCROLLBAR--------------------------------------------------------------*/	

		private void vScrollBar1_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{	
			

			Point poi = new Point();
			poi.X = this.panel1.Location.X;
			poi.Y = this.panel1.Location.Y -e.NewValue+ LastScroll_V;
			LastScroll_V = e.NewValue;
			panel1.Location = poi;

		}

		private void hScrollBar1_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
				
			Point poi = new Point(panel1.Location.X - e.NewValue+ LastScroll_H ,panel1.Location.Y );
			poi.X = this.panel1.Location.X - e.NewValue+ LastScroll_H;
			poi.Y = this.panel1.Location.Y;
			LastScroll_H = e.NewValue; 
			panel1.Location = poi;

		}

		

		private void Draw_graph_Resize(object sender, System.EventArgs e)
		{
			if(cordinatesRead)
			{
				horizon.addFirstPoint(this.panel1.Location.X+10,
					this.panel1.Location.Y+10);
				horizon.addLastPoint(this.panel1.Location.X+10,
					this.panel2.Location.Y-10);
				
				vertica.addFirstPoint(this.panel1.Location.X,
					this.panel2.Location.Y-20);
			
				vertica.addLastPoint(this.vScrollBar1.Location.X-20,
					this.panel2.Location.Y-20);
			
				cordinatesRead = true;
				this.narisiObjekte1();
			}
		
		}

		private void menu_angle_click(object sender, System.EventArgs e)
		{
			this.menuItem3.Checked = true;
			this.menuItem4.Checked = false;
			//this.menuItem5.Checked = false;
			//this.menuItem6.Checked = false;
		}

		private void menu_speed_click(object sender, System.EventArgs e)
		{
			this.menuItem3.Checked = false;
			this.menuItem4.Checked = true;
			//this.menuItem5.Checked = false;
			//this.menuItem6.Checked = false;
		
		}

		private void groupBox1_Enter_2(object sender, System.EventArgs e)
		{
			
		}

		
/*		private void menu_linear_click(object sender, System.EventArgs e)
		{
			this.menuItem3.Checked = false;
			this.menuItem4.Checked = false;
			this.menuItem5.Checked = true;
			this.menuItem6.Checked = false;
		
		}

		private void menu_acc_click(object sender, System.EventArgs e)
		{
			this.menuItem3.Checked = false;
			this.menuItem4.Checked = false;
			this.menuItem5.Checked = false;
			this.menuItem6.Checked = true;
		
		}
		*/
		/*-----------------------------------------------------------------------------------------------------------------*/
	
	}
}
