/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections; 

namespace symmetry
{
	/// <summary>
	/// Summary description for FinalObjects.
	/// </summary>
	public class FinalObjects
	{
		public FinalObjects()
		{
			//
			// TODO: Add constructor logic here
			//
		}
	}


	public class Pravokotnik
	{
		private Point p1,p2,p3,p4;


		public Pravokotnik()
		{
			
			p1 = new Point();
			p2 = new Point();
			p3 = new Point();
			p4 = new Point();
		
		}

		public void addPoints(Point r1,Point r2,Point r3,Point r4)
		{
			p1.X = r1.X;
			p1.Y = r1.Y;
			p2.X = r2.X;
			p2.Y = r2.Y;
			p3.X = r3.X;
			p3.Y = r3.Y;
			p4.X = r4.X;
			p4.Y = r4.Y;
			
		}


		public void addPoints(Point r1,Point r2,Point r3)
		{
			
			
			p1.X = r1.X;
			p1.Y = r1.Y;
			p2.X = r2.X;
			p2.Y = r2.Y;
			p3.X = r3.X;
			p3.Y = r3.Y;
			p4.X = p1.X -(p2.X -p3.X);
			p4.Y = p1.Y -(p2.Y -p3.Y);

		}


		public void narisiPrav(Pen p,Graphics g)
		{
			g.Clear(Color.White);
			g.DrawLine(p,p1,p2);
			g.DrawLine(p,p2,p3);
			g.DrawLine(p,p3,p4);
			g.DrawLine(p,p4,p1);
		}

	
	
	
	}
}
