using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace symmetry
{
	/// <summary>
	/// Summary description for SetRecognizer.
	/// </summary>
	public class SetRecognizer : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		private System.Windows.Forms.NumericUpDown numericUpDown2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.NumericUpDown numericUpDown3;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.TrackBar trackBar1;
		private Graphics g = null;
		private System.Windows.Forms.TrackBar trackBar2;
		private System.Windows.Forms.TrackBar trackBar3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.NumericUpDown numericUpDown4;
		private System.Windows.Forms.TrackBar trackBar4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.NumericUpDown numericUpDown5;
		private System.Windows.Forms.TrackBar trackBar5;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public SetRecognizer()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		
			numericUpDown1.Value = (decimal)Form1.razdaljaMedOgli;
			numericUpDown2.Value = (decimal)Form1.Hitrost_recognizer;
			numericUpDown3.Value = (decimal)Form1.razdaljaMedStikalisciTock;
			numericUpDown4.Value = (decimal)Recognizer2.odsopanjeOdVzporednosti;
			numericUpDown5.Value = (decimal)Recognizer2.ocutlivostVelikosti;

			trackBar1.Value = (int)numericUpDown3.Value;
			trackBar2.Value = (int)numericUpDown2.Value/20;
			trackBar3.Value = (int)numericUpDown1.Value;
			trackBar4.Value = (int)numericUpDown4.Value;
			trackBar5.Value = (int)numericUpDown5.Value*10;
			
		
			if( g == null)
				g = this.panel1.CreateGraphics();
			

		
		
		

			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.trackBar4 = new System.Windows.Forms.TrackBar();
			this.numericUpDown4 = new System.Windows.Forms.NumericUpDown();
			this.label4 = new System.Windows.Forms.Label();
			this.trackBar3 = new System.Windows.Forms.TrackBar();
			this.trackBar2 = new System.Windows.Forms.TrackBar();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.panel1 = new System.Windows.Forms.Panel();
			this.numericUpDown3 = new System.Windows.Forms.NumericUpDown();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.numericUpDown2 = new System.Windows.Forms.NumericUpDown();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			this.label5 = new System.Windows.Forms.Label();
			this.numericUpDown5 = new System.Windows.Forms.NumericUpDown();
			this.trackBar5 = new System.Windows.Forms.TrackBar();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.trackBar4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar5)).BeginInit();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.trackBar5);
			this.groupBox1.Controls.Add(this.numericUpDown5);
			this.groupBox1.Controls.Add(this.label5);
			this.groupBox1.Controls.Add(this.trackBar4);
			this.groupBox1.Controls.Add(this.numericUpDown4);
			this.groupBox1.Controls.Add(this.label4);
			this.groupBox1.Controls.Add(this.trackBar3);
			this.groupBox1.Controls.Add(this.trackBar2);
			this.groupBox1.Controls.Add(this.trackBar1);
			this.groupBox1.Controls.Add(this.panel1);
			this.groupBox1.Controls.Add(this.numericUpDown3);
			this.groupBox1.Controls.Add(this.label3);
			this.groupBox1.Controls.Add(this.label2);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.numericUpDown2);
			this.groupBox1.Controls.Add(this.numericUpDown1);
			this.groupBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.groupBox1.Location = new System.Drawing.Point(8, 16);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(528, 528);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Nastavitev za prepoznavo oglov";
			// 
			// trackBar4
			// 
			this.trackBar4.Location = new System.Drawing.Point(184, 376);
			this.trackBar4.Maximum = 180;
			this.trackBar4.Name = "trackBar4";
			this.trackBar4.Size = new System.Drawing.Size(336, 42);
			this.trackBar4.TabIndex = 12;
			this.trackBar4.Scroll += new System.EventHandler(this.trackBar4_Scroll);
			// 
			// numericUpDown4
			// 
			this.numericUpDown4.Location = new System.Drawing.Point(24, 384);
			this.numericUpDown4.Maximum = new System.Decimal(new int[] {
																		   180,
																		   0,
																		   0,
																		   0});
			this.numericUpDown4.Name = "numericUpDown4";
			this.numericUpDown4.TabIndex = 11;
			this.numericUpDown4.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown4_KeyUp);
			this.numericUpDown4.ValueChanged += new System.EventHandler(this.numericUpDown4_ValueChanged);
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label4.Location = new System.Drawing.Point(24, 336);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(168, 32);
			this.label4.TabIndex = 10;
			this.label4.Text = "Nastavitve odstopnega kota pri iskanju vzporednosti";
			// 
			// trackBar3
			// 
			this.trackBar3.Location = new System.Drawing.Point(192, 80);
			this.trackBar3.Maximum = 200;
			this.trackBar3.Name = "trackBar3";
			this.trackBar3.Size = new System.Drawing.Size(320, 42);
			this.trackBar3.TabIndex = 9;
			this.trackBar3.Scroll += new System.EventHandler(this.trackBar3_Scroll);
			// 
			// trackBar2
			// 
			this.trackBar2.Location = new System.Drawing.Point(192, 152);
			this.trackBar2.Maximum = 200;
			this.trackBar2.Name = "trackBar2";
			this.trackBar2.Size = new System.Drawing.Size(320, 42);
			this.trackBar2.TabIndex = 8;
			this.trackBar2.Scroll += new System.EventHandler(this.trackBar2_Scroll);
			// 
			// trackBar1
			// 
			this.trackBar1.Location = new System.Drawing.Point(192, 264);
			this.trackBar1.Maximum = 100;
			this.trackBar1.Minimum = 1;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(200, 42);
			this.trackBar1.TabIndex = 7;
			this.trackBar1.Value = 1;
			this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.panel1.Location = new System.Drawing.Point(408, 216);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(104, 104);
			this.panel1.TabIndex = 6;
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			// 
			// numericUpDown3
			// 
			this.numericUpDown3.Location = new System.Drawing.Point(24, 272);
			this.numericUpDown3.Name = "numericUpDown3";
			this.numericUpDown3.TabIndex = 5;
			this.numericUpDown3.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown3_KeyUp);
			this.numericUpDown3.ValueChanged += new System.EventHandler(this.numericUpDown3_ValueChanged);
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label3.Location = new System.Drawing.Point(24, 208);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(160, 32);
			this.label3.TabIndex = 4;
			this.label3.Text = "Kako blizu sta si lahko dve toki,da ju ne zdruimo";
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label2.Location = new System.Drawing.Point(24, 128);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(152, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "Hitrost ";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label1.Location = new System.Drawing.Point(24, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(160, 40);
			this.label1.TabIndex = 2;
			this.label1.Text = "Razdalja med sosednjimi prepoznanimi ogli";
			// 
			// numericUpDown2
			// 
			this.numericUpDown2.Location = new System.Drawing.Point(24, 168);
			this.numericUpDown2.Maximum = new System.Decimal(new int[] {
																		   4000,
																		   0,
																		   0,
																		   0});
			this.numericUpDown2.Name = "numericUpDown2";
			this.numericUpDown2.TabIndex = 1;
			this.numericUpDown2.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown2_KeyUp);
			this.numericUpDown2.ValueChanged += new System.EventHandler(this.numericUpDown2_ValueChanged);
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.Location = new System.Drawing.Point(24, 88);
			this.numericUpDown1.Maximum = new System.Decimal(new int[] {
																		   200,
																		   0,
																		   0,
																		   0});
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.TabIndex = 0;
			this.numericUpDown1.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown1_KeyUp);
			this.numericUpDown1.ValueChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label5.Location = new System.Drawing.Point(24, 432);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(152, 32);
			this.label5.TabIndex = 13;
			this.label5.Text = "Faktor zaokroevanja dolin";
			// 
			// numericUpDown5
			// 
			this.numericUpDown5.DecimalPlaces = 1;
			this.numericUpDown5.Location = new System.Drawing.Point(24, 480);
			this.numericUpDown5.Name = "numericUpDown5";
			this.numericUpDown5.TabIndex = 14;
			this.numericUpDown5.KeyUp += new System.Windows.Forms.KeyEventHandler(this.numericUpDown5_KeyUp);
			this.numericUpDown5.ValueChanged += new System.EventHandler(this.numericUpDown5_ValueChanged);
			// 
			// trackBar5
			// 
			this.trackBar5.Location = new System.Drawing.Point(192, 472);
			this.trackBar5.Maximum = 1000;
			this.trackBar5.Name = "trackBar5";
			this.trackBar5.Size = new System.Drawing.Size(320, 42);
			this.trackBar5.TabIndex = 15;
			this.trackBar5.Scroll += new System.EventHandler(this.trackBar5_Scroll);
			// 
			// SetRecognizer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 557);
			this.Controls.Add(this.groupBox1);
			this.Name = "SetRecognizer";
			this.Text = "SetRecognizer";
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.trackBar4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown4)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown2)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown5)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.trackBar5)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
		{
			
				Form1.razdaljaMedOgli = (int)numericUpDown1.Value;
				trackBar3.Value = (int)numericUpDown1.Value;
			
		}

		private void numericUpDown1_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			    Form1.razdaljaMedOgli = (int)numericUpDown1.Value;
				trackBar3.Value = (int)numericUpDown1.Value;
		}

		private void numericUpDown2_ValueChanged(object sender, System.EventArgs e)
		{
			Form1.Hitrost_recognizer = (int)numericUpDown2.Value;
			trackBar2.Value = (int)numericUpDown2.Value/20;
		}

		private void numericUpDown2_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Form1.Hitrost_recognizer = (int)numericUpDown2.Value;
			trackBar2.Value = (int)numericUpDown2.Value/20;
		}

		private void numericUpDown3_ValueChanged(object sender, System.EventArgs e)
		{
			int polmer = 0;
			Form1.razdaljaMedStikalisciTock = (int)numericUpDown3.Value;
			trackBar1.Value = (int)numericUpDown3.Value;
			polmer = Form1.razdaljaMedStikalisciTock;
			if( g == null)
				g = this.panel1.CreateGraphics();
			g.Clear(Color.White);
			Pen p = new Pen(Color.Red,1f);
			g.DrawEllipse(p,0,0,polmer,polmer);
			g.DrawEllipse(p,polmer/2,polmer/2,1,1);
		}

		private void numericUpDown3_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			int polmer = 0;
			Form1.razdaljaMedStikalisciTock = (int)numericUpDown3.Value;
			trackBar1.Value = (int)numericUpDown3.Value;
			polmer = Form1.razdaljaMedStikalisciTock;
			if( g == null)
				g = this.panel1.CreateGraphics();
			g.Clear(Color.White);
			Pen p = new Pen(Color.Red,1f);
			g.DrawEllipse(p,0,0,polmer,polmer);
			g.DrawEllipse(p,polmer/2,polmer/2,1,1);
		}

		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			int polmer = 0;
			Form1.razdaljaMedStikalisciTock = (int)trackBar1.Value;
			numericUpDown3.Value =(int)trackBar1.Value;
			polmer = Form1.razdaljaMedStikalisciTock;
			if( g == null)
				g = this.panel1.CreateGraphics();
			g.Clear(Color.White);
			Pen p = new Pen(Color.Red,1f);
			g.DrawEllipse(p,0,0,polmer,polmer);
	  	    g.DrawEllipse(p,polmer/2,polmer/2,1,1);
		}

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			int polmer = 0;
			polmer = Form1.razdaljaMedStikalisciTock;
			if( g == null)
				g = this.panel1.CreateGraphics();
			g.Clear(Color.White);
			Pen p = new Pen(Color.Red,1f);
			g.DrawEllipse(p,0,0,polmer,polmer);
			g.DrawEllipse(p,polmer/2,polmer/2,1,1);

		}

		private void trackBar2_Scroll(object sender, System.EventArgs e)
		{
			Form1.Hitrost_recognizer = (int)trackBar2.Value*20;
			numericUpDown2.Value =(int)trackBar2.Value*20;
		
		}

	

		private void trackBar3_Scroll(object sender, System.EventArgs e)
		{
			Form1.razdaljaMedOgli = (int)trackBar3.Value;
			numericUpDown1.Value =(int)trackBar3.Value;

		}


		private void numericUpDown4_ValueChanged(object sender, System.EventArgs e)
		{
			Recognizer2.odsopanjeOdVzporednosti = (int)numericUpDown4.Value;
			trackBar4.Value = (int)numericUpDown4.Value;
		}

		
		private void numericUpDown4_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Recognizer2.odsopanjeOdVzporednosti = (int)numericUpDown4.Value;
			trackBar4.Value = (int)numericUpDown4.Value;
		
		}

		
		private void trackBar4_Scroll(object sender, System.EventArgs e)
		{
			Recognizer2.odsopanjeOdVzporednosti = (int)trackBar4.Value;
			numericUpDown4.Value = (int)trackBar4.Value;
		}

		
		private void numericUpDown5_ValueChanged(object sender, System.EventArgs e)
		{
			Recognizer2.ocutlivostVelikosti = (double)numericUpDown5.Value;
			trackBar5.Value = (int)numericUpDown5.Value*10;
		
		}

		private void numericUpDown5_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			Recognizer2.ocutlivostVelikosti = (double)numericUpDown5.Value;
			trackBar5.Value = (int)numericUpDown5.Value*10;
		
		}

		private void trackBar5_Scroll(object sender, System.EventArgs e)
		{
			Recognizer2.ocutlivostVelikosti = (double)trackBar5.Value/10;
			numericUpDown5.Value = (decimal)trackBar5.Value/10;
		
		}

	




		
	}
}
